/* objcomp.p -- Roundtable Compile Utility
This utility reads the rtb_inst/compctrl file to determine how to compile
objects in the Workspace.  The compctrl file is a text file with records
in EXPORT format.

*/

/* Define Shared */
/* Define New Shared */
/* Define Locals */

DEFINE WORKFILE Wcomp NO-UNDO
   FIELD object AS CHARACTER
   FIELD rec-type AS INTEGER
   FIELD comp-status AS CHARACTER
   FIELD attrspace   AS LOGICAL
   FIELD save-into   AS CHARACTER.

DEFINE VARIABLE Mfilepos AS INTEGER NO-UNDO.
DEFINE VARIABLE Mlastpos AS INTEGER NO-UNDO.
DEFINE VARIABLE Mpath    AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mrcode   AS CHARACTER NO-UNDO.

DEFINE STREAM Sin1.
DEFINE STREAM Sout1.

/* End of Defines */

INPUT STREAM Sin1 FROM rtb_inst/compath NO-ECHO.
IMPORT STREAM Sin1 Mpath.
INPUT STREAM Sin1 CLOSE.
PROPATH = Mpath + "," + PROPATH.

OUTPUT TO rtb_inst/comperr NO-ECHO.
PAUSE 0 BEFORE-HIDE.

Mfilepos = 0.
REPEAT:
   /* Get next compile control record */
   INPUT STREAM Sin1 FROM rtb_inst/compctrl NO-ECHO.
   SEEK STREAM Sin1 TO Mfilepos.
   CREATE Wcomp.
   IMPORT STREAM Sin1 Wcomp.
   Mlastpos = Mfilepos.
   Mfilepos = SEEK(Sin1).
   INPUT STREAM Sin1 CLOSE.

   IF Wcomp.comp-status <> "M" THEN NEXT. 

   PUT UNFORMATTED "Compiling: " Wcomp.object SKIP.

   IF Wcomp.attrspace THEN 
      COMPILE VALUE(Wcomp.object) ATTR-SPACE SAVE.
   ELSE 
      COMPILE VALUE(Wcomp.object) NO-ATTR-SPACE SAVE.

   IF Wcomp.save-into <> "" THEN 
      DO:
      IF 0 <> R-INDEX(Wcomp.object,".") 
         THEN Mrcode=SUBSTRING(Wcomp.object,1,R-INDEX(Wcomp.object,".") - 1) 
                    + ".r".
         ELSE Mrcode=Wcomp.object + ".r".

      OS-CREATE-DIR VALUE(Wcomp.save-into).
      OS-COPY VALUE(Mrcode) VALUE(Wcomp.save-into). 
      OS-DELETE VALUE(Mrcode).
      END.

   OUTPUT STREAM Sout1 TO rtb_inst/compctrl NO-ECHO APPEND.
   SEEK STREAM Sout1 TO Mlastpos + LENGTH(Wcomp.object) + 6.
   PUT STREAM Sout1 UNFORMATTED "C".
   OUTPUT STREAM Sout1 CLOSE.
   DELETE Wcomp.
END.

OUTPUT CLOSE.
PAUSE BEFORE-HIDE.
PAUSE 0.
