/* selcomp.p -- Roundtable selective compile utility
   This procedure reads the rtb_idat/selcomp file and updates the
   rtb_inst/compctrl files compile status flags.  For each object 
   in the selcomp file the compile flag in the rtb_inst/compctrl flag
   is set.

   To compile these objects do an _install.
*/
/* Define shared */
/* Define new shared */
/* Define Locals */

DEFIN WORKFILE Wcomp NO-UNDO
  FIELD object AS CHARACTER
  FIELD rec-type AS INTEGER
  FIELD comp-status AS CHARACTER
  FIELD attrspace AS LOGICAL
  FIELD save-into AS CHARACTER.

DEFINE VARIABLE Mobject AS CHARACTER NO-UNDO.

DEFINE STREAM Sin1.
DEFINE STREAM Sin2.
DEFINE STREAM Sout1.

/* End of Defines */

PAUSE 0 BEFORE-HIDE.

CREATE Wcomp.

INPUT STREAM Sin1 FROM rtb_idat/selcomp NO-ECHO.
INPUT STREAM Sin2 FROM rtb_inst/compctrl NO-ECHO.
OUTPUT STREAM Sout1 TO rtb_inst/compctrl.tmp NO-ECHO.

REPEAT: /* Get compile control record from selcomp */
   IMPORT STREAM Sin1 Mobject.

   REPEAT: /* Get next compile control record */
      IMPORT STREAM Sin2 Wcomp.
      IF Wcomp.object = Mobject OR Mobject = "@@fullcomp"
         THEN Wcomp.comp-status = "M".

      EXPORT STREAM Sout1 Wcomp. 

      IF Wcomp.object < Mobject 
      OR Mobject = "@@fullcomp" 
         THEN NEXT. /* get next record from compctrl file */
         ELSE LEAVE.  /* go back around for next object from selcomp file */ 
   END.  
END.

INPUT STREAM Sin1 CLOSE.

/* Read thru remaining portion of compctrl, if any, and write it out
   to the compctrl.tmp file! */
REPEAT:
   IMPORT STREAM Sin2 Wcomp NO-ERROR.
   IF ERROR-STATUS:ERROR THEN LEAVE.
   EXPORT STREAM Sout1 Wcomp.
END.

INPUT STREAM Sin2 CLOSE.
OUTPUT STREAM Sout1 CLOSE.

OS-COPY "rtb_inst/compctrl.tmp" "rtb_inst/compctrl".
OS-DELETE "rtb_inst/compctrl.tmp".

PAUSE BEFORE-HIDE.
PAUSE 0.

